<?php


class CrossSellingOverride extends CrossSelling
{

     public function hookProductFooter($params) {
        
        if (!Module::isInstalled('aqurate') or !Module::isEnabled('aqurate')) return parent::hookProductFooter($params);
        
        $aqurate_module = Module::getInstanceByName('aqurate');
        if (!$aqurate_module) return parent::hookProductFooter($params);
        
        $product_ids = false;
        
        if (Tools::getValue('controller') == 'product') {
            
            if (!Configuration::get('AQURATE_CROSSSELLING_PRODUCT')) return parent::hookProductFooter($params);
            
            $product_ids = $this->getProductPageProds($aqurate_module);
            
        }
        else if (Tools::getValue('controller') == 'cart') {
            
            if (!Configuration::get('AQURATE_CROSSSELLING_CART') && !Configuration::get('AQURATE_SIMILAR_CART')) return parent::hookProductFooter($params);
            
            $product_ids = $this->getCartPageProds($aqurate_module);
        }
        
        if (!$product_ids) return parent::hookProductFooter($params);
        

        $products = $this->convertToPrestaProducts($product_ids);
        
        if (!empty($products)) {
            
           $this->smarty->assign(
                    array(
                        'orderProducts' => $products,
                        'middlePosition_crossselling' => round(count($products) / 2, 0),
                        'crossDisplayPrice' => Configuration::get('CROSSSELLING_DISPLAY_PRICE')
                    )
            );
            
           //return $this->display('module:crossselling/views/templates/hook/crossselling.tpl');
           return $this->display(_PS_ROOT_DIR_.'/modules/crossselling/crossselling.php','crossselling.tpl');  
               
            
         } else return parent::hookProductFooter($params);
         
         
        
    }
    
    
    public function hookshoppingCart($params)
    {
        
        if (!Module::isInstalled('aqurate') or !Module::isEnabled('aqurate')) return parent::hookshoppingCart($params);
        
        $aqurate_module = Module::getInstanceByName('aqurate');
        if (!$aqurate_module) return parent::hookshoppingCart($params);
        
        $product_ids = false;
        
        if (Tools::getValue('controller') == 'product') {
            
            if (!Configuration::get('AQURATE_CROSSSELLING_PRODUCT')) return parent::hookshoppingCart($params);
            
            $product_ids = $this->getProductPageProds($aqurate_module);
            
        }
        else if (Tools::getValue('controller') == 'cart') {
            
            if (!Configuration::get('AQURATE_CROSSSELLING_CART') && !Configuration::get('AQURATE_SIMILAR_CART')) return parent::hookshoppingCart($params);
            
            $product_ids = $this->getCartPageProds($aqurate_module);
        }
        
        if (!$product_ids) return parent::hookshoppingCart($params);
        

        $products = $this->convertToPrestaProducts($product_ids);
        
        if (!empty($products)) {
            
           $this->smarty->assign(
                    array(
                        'orderProducts' => $products,
                        'middlePosition_crossselling' => round(count($products) / 2, 0),
                        'crossDisplayPrice' => Configuration::get('CROSSSELLING_DISPLAY_PRICE')
                    )
            );
            
           //return $this->display('module:crossselling/views/templates/hook/crossselling.tpl');
            return $this->display(_PS_ROOT_DIR_.'/modules/crossselling/crossselling.php','crossselling.tpl');
               
            
         } else return parent::hookshoppingCart($params);
        
    }
    
    
    public function getProductPageProds($aqurate_module) {
        
        if (!Tools::getValue('id_product')) return false;
        
        return $aqurate_module->clasa->getCrossSellingProducts(Tools::getValue('id_product'));
           
    }
    
    
    public function getCartPageProds($aqurate_module) {
        
        $highest_value_product_id = 0;
        $highest_value_product_price = 0;
        
        $cart = new Cart(Context::getContext()->cart->id);
        if (!isset($cart->id)) return false;
        
        foreach ($cart->getProducts() as $p) {
            
            $price = Product::getPriceStatic($p['id_product'], true, false, 4, NULL, false, true, 1, false, null, null, null);
            if ($price > $highest_value_product_price) {
                $highest_value_product_id = $p['id_product'];
                $highest_value_product_price = $price;
            }
    
        }
        
        if ($highest_value_product_id == 0) return false;
        
        if (Configuration::get('AQURATE_CROSSSELLING_CART'))
            return $aqurate_module->clasa->getCrossSellingProducts($highest_value_product_id);
        else if (Configuration::get('AQURATE_SIMILAR_CART'))
            return $aqurate_module->clasa->getSimilarProducts($highest_value_product_id);
          
        
    }

    
      public function convertToPrestaProducts($product_ids) {
        
        $nb_days_new_product = 20;
        
        $context = Context::getContext();
        
        $id_lang = $context->language->id;
        
        $active = true;
        
        $front = true;
        
        $id_supplier = false;
        
        $sql = 'SELECT p.*, product_shop.*, stock.out_of_stock, IFNULL(stock.quantity, 0) AS quantity'.(Combination::isFeatureActive() ? ', IFNULL(product_attribute_shop.id_product_attribute, 0) AS id_product_attribute,
					product_attribute_shop.minimal_quantity AS product_attribute_minimal_quantity' : '').', pl.`description`, pl.`description_short`, pl.`available_now`,
					pl.`available_later`, pl.`link_rewrite`, pl.`meta_description`, pl.`meta_keywords`, pl.`meta_title`, pl.`name`, image_shop.`id_image` id_image,
					il.`legend` as legend, m.`name` AS manufacturer_name, cl.`name` AS category_default,
					DATEDIFF(product_shop.`date_add`, DATE_SUB("'.date('Y-m-d').' 00:00:00",
					INTERVAL '.(int)$nb_days_new_product.' DAY)) > 0 AS new, product_shop.price AS orderprice
				FROM `'._DB_PREFIX_.'product` p
				'.Shop::addSqlAssociation('product', 'p').
                (Combination::isFeatureActive() ? ' LEFT JOIN `'._DB_PREFIX_.'product_attribute_shop` product_attribute_shop
				ON (p.`id_product` = product_attribute_shop.`id_product` AND product_attribute_shop.`default_on` = 1 AND product_attribute_shop.id_shop='.(int)$context->shop->id.')':'').'
				'.Product::sqlStock('p', 0).'
				LEFT JOIN `'._DB_PREFIX_.'category_lang` cl
					ON (product_shop.`id_category_default` = cl.`id_category`
					AND cl.`id_lang` = '.(int)$id_lang.Shop::addSqlRestrictionOnLang('cl').')
				LEFT JOIN `'._DB_PREFIX_.'product_lang` pl
					ON (p.`id_product` = pl.`id_product`
					AND pl.`id_lang` = '.(int)$id_lang.Shop::addSqlRestrictionOnLang('pl').')
				LEFT JOIN `'._DB_PREFIX_.'image_shop` image_shop
					ON (image_shop.`id_product` = p.`id_product` AND image_shop.cover=1 AND image_shop.id_shop='.(int)$context->shop->id.')
				LEFT JOIN `'._DB_PREFIX_.'image_lang` il
					ON (image_shop.`id_image` = il.`id_image`
					AND il.`id_lang` = '.(int)$id_lang.')
				LEFT JOIN `'._DB_PREFIX_.'manufacturer` m
					ON m.`id_manufacturer` = p.`id_manufacturer`
				WHERE product_shop.`id_shop` = '.(int)$context->shop->id.'
					AND p.`id_product` IN ('.implode(',',$product_ids).')'.($active ? ' AND product_shop.`active` = 1' : '')
                    .($front ? ' AND product_shop.`visibility` IN ("both", "catalog")' : '')
                    .($id_supplier ? ' AND p.id_supplier = '.(int)$id_supplier : '');
        
         $result = Db::getInstance(_PS_USE_SQL_SLAVE_)->executeS($sql, true, false);

         if (!$result) {
                return false;
          }
        
          $tax_calc = Product::getTaxCalculationMethod();
        
          $products = array();
            foreach ($product_ids as $id_product) {
                foreach ($result as $p) {
                    if ($p['id_product'] == $id_product) {
                        $p['image'] = $this->context->link->getImageLink($p['link_rewrite'],
                    (int)$p['id_product'].'-'.(int)$p['id_image'], ImageType::getFormatedName('home'));
                        
                        if (Configuration::get('CROSSSELLING_DISPLAY_PRICE') && ($tax_calc == 0 || $tax_calc == 2)) {
                            $p['displayed_price'] = Product::getPriceStatic((int)$p['id_product'], true, null);
                        } elseif (Configuration::get('CROSSSELLING_DISPLAY_PRICE') && $tax_calc == 1) {
                            $p['displayed_price'] = Product::getPriceStatic((int)$p['id_product'], false, null);
                        }
                        
                        $products[] = $p;
                    }
                }   
            }
          
         if (!$products) {
                return false;
          }

            
          return Product::getProductsProperties($id_lang, $products);
        
        
    }
    
    

    
    
    
}