<?php

class ProductsCategoryOverride extends ProductsCategory
{

    
    public function hookProductFooter($params)
	{
        
        if ((Tools::getValue('controller') != 'product') or !Module::isInstalled('aqurate') or !Module::isEnabled('aqurate')) return parent::hookProductFooter($params);
        
        if (!Configuration::get('AQURATE_SUBSTITUTE_PRODUCT') && !Configuration::get('AQURATE_SIMILAR_PRODUCT')) return parent::hookProductFooter($params);
        
        $aqurate_module = Module::getInstanceByName('aqurate');

        if (!$aqurate_module) return parent::hookProductFooter($params);
        
        if (Configuration::get('AQURATE_SUBSTITUTE_PRODUCT'))
           $product_ids = $aqurate_module->clasa->getSubstituteProducts(Tools::getValue('id_product'));
        else if (Configuration::get('AQURATE_SIMILAR_PRODUCT'))
            $product_ids = $aqurate_module->clasa->getSimilarProducts(Tools::getValue('id_product'));
            
        if ($product_ids)
            $products = $this->convertToPrestaProducts($product_ids);
        else return parent::hookProductFooter($params);
        
        if (!empty($products)) {
            
            $this->smarty->assign(
            array(
                'categoryProducts' => $products,
                'middlePosition' => round(count($products) / 2),
                'ProdDisplayPrice' => Configuration::get('PRODUCTSCATEGORY_DISPLAY_PRICE')
                )
            );
		
            return $this->display(_PS_ROOT_DIR_.'/modules/productscategory/productscategory.php','productscategory.tpl');
                
            
         } else parent::hookProductFooter($params);
        
        
		
        
	}

    
    
    public function convertToPrestaProducts($product_ids) {
        
        $nb_days_new_product = 20;
        
        $context = Context::getContext();
        
        $id_lang = $context->language->id;
        
        $active = true;
        
        $front = true;
        
        $id_supplier = false;
        
        $sql = 'SELECT p.*, product_shop.*, stock.out_of_stock, IFNULL(stock.quantity, 0) AS quantity'.(Combination::isFeatureActive() ? ', IFNULL(product_attribute_shop.id_product_attribute, 0) AS id_product_attribute,
					product_attribute_shop.minimal_quantity AS product_attribute_minimal_quantity' : '').', pl.`description`, pl.`description_short`, pl.`available_now`,
					pl.`available_later`, pl.`link_rewrite`, pl.`meta_description`, pl.`meta_keywords`, pl.`meta_title`, pl.`name`, image_shop.`id_image` id_image,
					il.`legend` as legend, m.`name` AS manufacturer_name, cl.`name` AS category_default,
					DATEDIFF(product_shop.`date_add`, DATE_SUB("'.date('Y-m-d').' 00:00:00",
					INTERVAL '.(int)$nb_days_new_product.' DAY)) > 0 AS new, product_shop.price AS orderprice
				FROM `'._DB_PREFIX_.'product` p
				'.Shop::addSqlAssociation('product', 'p').
                (Combination::isFeatureActive() ? ' LEFT JOIN `'._DB_PREFIX_.'product_attribute_shop` product_attribute_shop
				ON (p.`id_product` = product_attribute_shop.`id_product` AND product_attribute_shop.`default_on` = 1 AND product_attribute_shop.id_shop='.(int)$context->shop->id.')':'').'
				'.Product::sqlStock('p', 0).'
				LEFT JOIN `'._DB_PREFIX_.'category_lang` cl
					ON (product_shop.`id_category_default` = cl.`id_category`
					AND cl.`id_lang` = '.(int)$id_lang.Shop::addSqlRestrictionOnLang('cl').')
				LEFT JOIN `'._DB_PREFIX_.'product_lang` pl
					ON (p.`id_product` = pl.`id_product`
					AND pl.`id_lang` = '.(int)$id_lang.Shop::addSqlRestrictionOnLang('pl').')
				LEFT JOIN `'._DB_PREFIX_.'image_shop` image_shop
					ON (image_shop.`id_product` = p.`id_product` AND image_shop.cover=1 AND image_shop.id_shop='.(int)$context->shop->id.')
				LEFT JOIN `'._DB_PREFIX_.'image_lang` il
					ON (image_shop.`id_image` = il.`id_image`
					AND il.`id_lang` = '.(int)$id_lang.')
				LEFT JOIN `'._DB_PREFIX_.'manufacturer` m
					ON m.`id_manufacturer` = p.`id_manufacturer`
				WHERE product_shop.`id_shop` = '.(int)$context->shop->id.'
					AND p.`id_product` IN ('.implode(',',$product_ids).')'.($active ? ' AND product_shop.`active` = 1' : '')
                    .($front ? ' AND product_shop.`visibility` IN ("both", "catalog")' : '')
                    .($id_supplier ? ' AND p.id_supplier = '.(int)$id_supplier : '');
        
         $result = Db::getInstance(_PS_USE_SQL_SLAVE_)->executeS($sql, true, false);

         if (!$result) {
                return false;
          }
        
          $products = array();
            foreach ($product_ids as $id_product) {
                foreach ($result as $p) {
                    if ($p['id_product'] == $id_product)
                        $products[] = $p;
                }   
            }
             
         if (!$products) {
                return false;
          }

            
          return Product::getProductsProperties($id_lang, $products);
        
        
    }
    
    

    
    
    
}